commit b7cd226e5ae6e6418e48d7c6204bce4d181292db
Author: cagy <ml.cagy@seznam.cz>
Date:   Mon Aug 17 21:44:01 2020 +0200

    re #8168 - added select picker for enum values in filter export

diff --git a/src/main/webapp/WEB-INF/templates/assembly.html b/src/main/webapp/WEB-INF/templates/assembly.html
index 2c285353..f1ecf7ae 100644
--- a/src/main/webapp/WEB-INF/templates/assembly.html
+++ b/src/main/webapp/WEB-INF/templates/assembly.html
@@ -66,7 +66,7 @@
                                     </optional>
                                 </td>
                                 <td class="s">
-                                    <div class="col select-filter">
+                                    <div th:unless="${configuration.parametersInConfiguration[__${itemStat.index}__].parameter.parameterType.name.equals('Výčet')}" class="col select-filter">
                                         <select class="form-control"
                                                 th:field="${configuration.parametersInConfiguration[__${itemStat.index}__].operator.name}">
                                             <option th:value="zadny" selected value> -- Operátor --</option>
@@ -76,6 +76,12 @@
                                         <input type="text" class="form-control select-filter-input"
                                                th:field="${configuration.parametersInConfiguration[__${itemStat.index}__].operatorValue}">
                                     </div>
+                                    <div th:if="${configuration.parametersInConfiguration[__${itemStat.index}__].parameter.parameterType.name.equals('Výčet')}" class="col select-filter">
+                                        <select class="mbSelect selectpicker assembly-enum-picker" multiple data-live-search="true" title="Nic nevybráno">
+                                            <option value="0" >Hodnota 1</option>
+                                            <option value="1">Hodnota 2</option>
+                                        </select>
+                                    </div>
                                 </td>
 
                                 <select class="form-control hidden" th:id="'function-select-' + ${itemStat.index}"
diff --git a/src/main/webapp/WEB-INF/templates/assembly_manage.html b/src/main/webapp/WEB-INF/templates/assembly_manage.html
index f771cde8..d707f83a 100644
--- a/src/main/webapp/WEB-INF/templates/assembly_manage.html
+++ b/src/main/webapp/WEB-INF/templates/assembly_manage.html
@@ -143,7 +143,7 @@
                     <div class="form-group row">
                         <label for="exampleFormControlSelect1" class="col-sm-2">Funkce:</label>
                         <div class="col-sm-10">
-                          <select th:field="*{parameters[__${i.index}__].functions}" class="mbSelect selectpicker" multiple data-live-search="true">
+                          <select th:field="*{parameters[__${i.index}__].functions}" class="mbSelect selectpicker" multiple data-live-search="true" title="Nic nevybráno">
                             <option th:each="function : ${allFunctions}" th:value="${{function.id}}" th:text="${function.name}"></option>
                           </select>
                         </div>
@@ -151,7 +151,7 @@
                     <div class="form-group row">
                         <label for="exampleFormControlSelect1" class="col-sm-2">Operátory:</label>
                         <div class="col-sm-10">
-                          <select th:field="*{parameters[__${i.index}__].operators}" class="mbSelect selectpicker" multiple data-live-search="true">
+                          <select th:field="*{parameters[__${i.index}__].operators}" class="mbSelect selectpicker" multiple data-live-search="true" title="Nic nevybráno">
                             <option th:each="operator : ${allOperators}" th:value="${{operator.id}}" th:text="${operator.name}"></option>
                           </select>
                         </div>
diff --git a/src/main/webapp/css/style.css b/src/main/webapp/css/style.css
index a4cca94c..d6059a46 100644
--- a/src/main/webapp/css/style.css
+++ b/src/main/webapp/css/style.css
@@ -414,4 +414,8 @@ table .col-3-p { width:10%; }
   87.5% {
     box-shadow: 0em -3em 0 0, 2em -2em 0 -1em, 3em 0 0 -1em, 2em 2em 0 -1em, 0 3em 0 -1em, -2em 2em 0 0, -3em 0em 0 0, -2em -2em 0 0.2em;
   }
+}
+
+.assembly-enum-picker {
+  width: 100% !important;
 }
\ No newline at end of file